#include <stdlib.h>
#include <math.h>

#define grid_width 8
#define grid_height 8
#define grid_size grid_height*grid_width

int PlayerId;
int PlayerScores[2];
static signed short PlayGrid[grid_size];

signed short GetTile(int x,int y)
{
	return PlayGrid[(y*grid_width)+x];
}


static  signed short Scores[63] = {
	-10,-10,-10,
	-9,-9,-9,
	-8,-8,-8,
	-7,-7,-7,
	-6,-6,-6,
	-5,-5,-5,
	-4,-4,-4,
	-3,-3,-3,
	-2,-2,-2,
	-1,-1,-1,
	1,1,1,
	2,2,2,
	3,3,3,
	4,4,4,
	5,5,5,
	6,6,6,
	7,7,7,
	8,8,8,
	9,9,9,
	10,10,10,
	11,11,11
};

/* find best */
unsigned short findBestOrWorst(unsigned short offset, unsigned short increment, char rmax, unsigned short worst )
{
	unsigned short  r;
	signed short *gridptr = PlayGrid+offset;
	signed short val_best;
	unsigned short val_r;

	/* really small number */
	if (worst)
	{
		val_best = 99;
	}
	else
	{
		val_best = -99;
	}
	val_r = -1;

	for (r=0; r<rmax; r++)
	{
		/* value in grid */
		signed short val = gridptr[0];

		if (val!=0)
		{
			unsigned short store = 0;
			if (worst)
			{
				if (val<val_best)
				{
					store = 1;
				}
			}
			else
			{
				if (val>val_best)
				{
					store = 1;
				}
			}

			/* find the highest value */
			if (store)
			{
				val_best = val;
				val_r = r;
			}
		}
		gridptr+=increment;
	}

	return val_r;
}

int negativecount;
int positivecount;
signed int smallest;
signed int largest;
signed int bestdist;
int bestpos = -1;
int worstpos = -1;

int getstats(unsigned short offset, unsigned short increment, unsigned short rmax, int chosen)
{
	unsigned short  r;
	signed short *gridptr = PlayGrid+offset;

    negativecount = 0;
    positivecount = 0;
    smallest = 255;
    largest = -255;

	for (r=0; r<rmax; r++)
	{
	    if (r!=chosen)
	    {
            /* value in grid */
            signed short val = gridptr[0];

            if (val!=0)
            {
                if (val<0)
                {
                    negativecount++;

                }
                else if (val>0)
                {
                    positivecount++;
				}
                if (val<smallest)
                {
                    smallest = val;
                    worstpos = r;
                }

                if (val>largest)
                {
                    largest = val;
                    bestpos = r;
                }
            }
	    }
		gridptr+=increment;
	}

	if ((smallest==255) || (largest==-255))
	{
		return 0;
	}

	return 1;
}

int CursorX, CursorY;

#define MAX_MOVES 4
/* x coordinate stored */
static char StoredCoords[MAX_MOVES*2];
/* num stored */
static char NumStored;
/* player scores stored */
static int StoredScores[MAX_MOVES+2];

static char BestCoords[2];
static signed int BestDist;
static signed int BestDistTheirScore;
static signed int BestDistNoMove;
static signed int BestDistNeg;
static signed int BestDistNegTheirScore;
static char BestCoordsSet;
static int CurrentAIPlayer;
static int StoredAIPlayer;

void InitAIMove()
{
	BestCoordsSet = 0;
	StoredAIPlayer = CurrentAIPlayer = PlayerId;

	memset(StoredScores, 0, sizeof(StoredScores));

	/* store initial scores */
	if (PlayerId==0)
	{
		StoredScores[0] = PlayerScores[0];
		StoredScores[1] = PlayerScores[1];
	}
	else
	{
		StoredScores[0] = PlayerScores[1];
		StoredScores[1] = PlayerScores[0];
	}


	NumStored = 0;
}

/* return 1 if this square is safe to take e.g. not taken already */
int AISquareNotChosen(int x, int y)
{
	int i;
	for (i=0; i<NumStored<<1; i+=2)
	{
		/* we have taken this square already */
		if ((StoredCoords[i]==x) && (StoredCoords[i+1]==y))
			return 0;
	}
	return 1;
}

void SwapAIPlayer()
{
/* swap player */
					CurrentAIPlayer = CurrentAIPlayer^1;
}
#if 0
void DoAIMove(int xstart, int ystart, int Depth)
{
	int checkmove = 1;
	if (Depth!=0)
	{
		int x,y;
		int xinc, yinc;
		/* based on current player, choose where to scan grid */
		if (CurrentAIPlayer==0)
		{
			xinc=1;
			yinc=0;
			x = 0;
			y = ystart;
		}
		else
		{
			xinc=0;
			yinc=1;
			x = xstart;
			y = 0;
		}
		/* scan whole column or row */
		while ((x<grid_width) && (y<grid_height))
		{
			/* get tile */
			signed char Tile = GetTile(x,y);

			/* tile not taken */
			if (Tile!=0)
			{



				/* tile not chosen */
				if (AISquareNotChosen(x,y))
				{
					/* get score offset in table */
					int ScoreOffset = NumStored;
					/* update score */
					/* get current score */
					signed int CurrentScore = StoredScores[ScoreOffset];
					/* calc new */
					signed int NewScore = CurrentScore + (signed int)Tile;
					int CoordOffset;
					/* store new */
					StoredScores[ScoreOffset+2] = NewScore;

					/* not reached depth yet */
					/* store the coords chosen */
					CoordOffset = NumStored<<1;
					StoredCoords[CoordOffset] = x;
					StoredCoords[CoordOffset+1] = y;

					NumStored++;

					/* swap player */
					SwapAIPlayer();

					/* do move for this player */
					DoAIMove(x,y,Depth-1);

					SwapAIPlayer();

					StoredScores[ScoreOffset+2] = 0;

					NumStored--;

					checkmove = 0;
				}
			}
			/* increment x and y to move accross or down grid */
			x += xinc;
			y += yinc;
		}
	}

	if (checkmove)
	{
		/* reached depth */
		int ScoreOffsetStartPlayer;
		int ScoreOffsetNextPlayer;
		signed int ScoreStartPlayer;
		signed int ScoreNextPlayer;
		signed int newdist;

		// copy previous score for other player
		if ((NumStored & 1)!=0)
		{
			StoredScores[NumStored+2] = StoredScores[NumStored];
		}

		/* now check if we would win */
		ScoreOffsetStartPlayer = NumStored;
		ScoreStartPlayer = StoredScores[ScoreOffsetStartPlayer];

	//	CurrentAIPlayer = CurrentAIPlayer^1;

		ScoreOffsetNextPlayer = NumStored+1;
		ScoreNextPlayer = StoredScores[ScoreOffsetNextPlayer];

	//	CurrentAIPlayer = CurrentAIPlayer^1;


		// if my score is higher choose it
		// if my score is lower don't choose it unless it makes me closer
		newdist = ScoreStartPlayer - ScoreNextPlayer;

		if (BestCoordsSet==0)
		{
			int x = StoredCoords[0];
			int y = StoredCoords[1];
			BestCoords[0] = x;
			BestCoords[1] = y;
			BestCoordsSet = 1;

			BestDist = newdist;
		}
		else
		{
			if (newdist>BestDist)
			{
				int x = StoredCoords[0];
				int y = StoredCoords[1];
				BestCoords[0] = x;
				BestCoords[1] = y;
				BestCoordsSet = 1;
				BestDist = newdist;
			}

		}



	}
}
#endif


int DoAIMove(int xstart, int ystart, int Depth)
{
	    int OurBestX;
	    int OurBestY;
		int OurBestNoMoveX;
		int OurBestNoMoveY;
		int OurBestNegX;
		int OurBestNegY;
  int OurBestSet=0;
		int OurBestNegSet=0;
		int OurBestNoMoveSet=0;

	int checkmove = 1;
	if (Depth!=0)
	{
	  
		int x,y;
		int xinc, yinc;
		/* based on current player, choose where to scan grid */
		if (CurrentAIPlayer==0)
		{
			xinc=1;
			yinc=0;
			x = 0;
			y = ystart;
		}
		else
		{
			xinc=0;
			yinc=1;
			x = xstart;
			y = 0;
		}

		printf("----------------------------------\n");
		printf("P1 Score: %d P2 Score %d\n\n", PlayerScores[0], PlayerScores[1]);
		printf("Cursor: %d %d\n", xstart, ystart);
		printf("We are: %d\n\n", CurrentAIPlayer);

		/* scan whole column or row */
		while ((x<grid_width) && (y<grid_height))
		{
			/* get tile */
			signed short Tile = GetTile(x,y);

			/* tile not taken */
			if (Tile!=0)
			{
                signed int dist = Tile;
				int movepossible;
				signed int tiledist;
				signed int scoredist;
				
				printf("======\n");
			    printf("Tile: %d\n\n",Tile);
                printf("Our Score after tile: %d\n", PlayerScores[StoredAIPlayer]+Tile);

			    if (CurrentAIPlayer==0)
			    {
			        /* column for next player */
			        movepossible = getstats(x, grid_width, grid_height, y);
			    }
			    else
			    {
			        /* row for next player */
			        movepossible = getstats((y*grid_width), 1, grid_width,x);
			    }

				if (movepossible)
				{
					scoredist = (PlayerScores[StoredAIPlayer]+Tile)-(PlayerScores[StoredAIPlayer^1]+largest);
					tiledist = Tile-largest;

					printf("their worst: %d (%d) best: %d (%d) numpos: %d numneg: %d\n", smallest, worstpos, largest, bestpos, positivecount, negativecount);
					printf("Dist: %d\n", tiledist);
					printf("Dist Scores: %d\n", scoredist);

					printf("Their Best/Worst Score: %d/%d\n",PlayerScores[StoredAIPlayer^1]+largest, PlayerScores[StoredAIPlayer^1]+smallest);

					if (tiledist!=scoredist)
					{
						printf("adasddas");
					}
					

#if 0
				if (!OurBestSet)
                {

                    /* compare against tile when scores begin */
                    /* try and find tile that has the closest and largest distance */

                    /* find where our score would be better than theirs if we took the number */
                    if (Tile>=largest)
                    {
                        OurBestSet = 1;
                        OurBestX = x;
                        OurBestY = y;
                    }
                }
                else
                {
                    /* find where our score would be better than theirs if we took the number */
                    if (Tile>=largest)
                    {
                        OurBestX = x;
                        OurBestY = y;
                    }
                }
#endif
					// if lots of negative numbers, work out our score and their best
					// then we can pick a number and force them to take negative
					if (largest<0)
					{
						if (!OurBestNegSet)
						{
							OurBestNegSet = 1;
							OurBestNegX = x;
							OurBestNegY = y;
							BestDistNeg = scoredist;
							BestDistNegTheirScore = PlayerScores[StoredAIPlayer^1]+largest;
						}
						else 
						{
							if (scoredist>BestDistNeg)
							{
								OurBestNegX = x;
								OurBestNegY = y;
								BestDistNeg = scoredist;
							}
							else if (scoredist==BestDistNeg)
							{
								if ((PlayerScores[StoredAIPlayer^1]+largest)<BestDistTheirScore)
								{
									OurBestNegX = x;
									OurBestNegY = y;
									BestDistNeg = scoredist;
									BestDistNegTheirScore = PlayerScores[StoredAIPlayer^1]+largest;
								}

								printf("adadasd");

							}
						}
					}
					else
					{

						if (!OurBestSet)
						{

							/* compare against tile when scores begin */
							/* try and find tile that has the closest and largest distance */

							/* find where our score would be better than theirs if we took the number */
							OurBestSet = 1;
							OurBestX = x;
							OurBestY = y;
							BestDist = scoredist;//;Tile-largest;
							BestDistTheirScore = PlayerScores[StoredAIPlayer^1]+largest;
						}
						else
						{
							/* find where our score would be better than theirs if we took the number */
							if (scoredist>BestDist)
							{
								OurBestX = x;
								OurBestY = y;
								BestDist = scoredist;//Tile-largest;
								BestDistTheirScore = PlayerScores[StoredAIPlayer^1]+largest;
							}
							else if (scoredist==BestDist)
							{
								if ((PlayerScores[StoredAIPlayer^1]+largest)<BestDistTheirScore)
								{
									OurBestX = x;
									OurBestY = y;
									BestDist = scoredist;//Tile-largest;
									BestDistTheirScore = PlayerScores[StoredAIPlayer^1]+largest;
								}
							}

							// what about equal?

						}
					}
				}
				else
				{		
					tiledist = Tile;
					scoredist = (PlayerScores[StoredAIPlayer]+Tile)-PlayerScores[StoredAIPlayer^1];

					if (!OurBestNoMoveSet)
					{
						OurBestNoMoveX = x;
						OurBestNoMoveY = y;
						BestDistNoMove = scoredist;
						OurBestNoMoveSet = 1;
					}
					else
					{
						if (scoredist>BestDistNoMove)
						{
							OurBestNoMoveX = x;
							OurBestNoMoveY = y;
							BestDistNoMove = scoredist;
						}
						else if (scoredist==BestDistNoMove)
						{

							printf("adasdsdasdas");

						}
					}	
				}
			}
			/* increment x and y to move accross or down grid */
			x += xinc;
			y += yinc;
		}
	}


	{
		int BestestDist;
		int BestestX;
		int BestestY;
		int BestestSet = 0;

		if (OurBestSet)
		{
			BestestSet = 1;
			BestestX = OurBestX;
			BestestY = OurBestY;
			BestestDist = BestDist;
		}

		if (OurBestNegSet)
		{
			if ((!BestestSet) || (BestDistNeg>BestestDist))
			{
				BestestSet = 1;
				BestestX = OurBestNegX;
				BestestY = OurBestNegY;
				BestestDist = BestDistNeg;
			}
		}

		// if no move is set, and distance is +ve, it
		// means our score will be better and we can end game early
		if (OurBestNoMoveSet)
		{
			if (BestDistNoMove>0)
			{
				BestestX = OurBestNoMoveX;
				BestestY = OurBestNoMoveY;
				BestestDist = BestDistNoMove;
				BestestSet = 1;
			}
		}

		if (BestestSet)
		{
			BestCoords[0] = BestestX;
			BestCoords[1] = BestestY;
		
			return 0;
		}
	}


	return 1;
}


int StartAI(int Depth)
{
	int startx, starty;
	InitAIMove();
	return DoAIMove(CursorX, CursorY, Depth);
}

int DoMediumAI()
{
	return StartAI(2);
}

int DoHardAI()
{
	return StartAI(4);
}

void showgrid()
{
	int y,x;

	for (y=0; y<grid_height; y++)
	{
		for (x=0; x<grid_width; x++)
		{
		    if (PlayGrid[(y*grid_width)+x]==0)
		    {
		        printf("--- ");
		    }
		    else
		    {
                printf("%+03d ", PlayGrid[(y*grid_width)+x]);
            }
		}
		printf("\n");
	}
	printf("\n");
}

#define NUM_SCORES 500

int ScoreSummary[NUM_SCORES*2];

int main()
{
	int p1wins, p2wins;
	int zzz;

	for (zzz=0; zzz<NUM_SCORES; zzz++)
	{
	    int i;

	{
		int sc;
		int c;
		signed short *pg;
		unsigned short choices[grid_size];
		short choicesremain;
		int y;

		short Cursor = rand()&(grid_size-1);
		CursorX = Cursor%grid_width;
		CursorY = Cursor/grid_height;

		/* init choices array; list of all possible choices as
		offset values into PlayGrid */
		for (sc = 0; sc<grid_size; sc++)
		{
			choices[sc] = sc;
		}

		/* exclude this choice */
		choices[Cursor] = 255;
		choicesremain = grid_size-1;

		for (y=0; y<grid_size; y++)
		{
			PlayGrid[y] = 0;
		}


		/* setup grid */

		/* one by one we make a choice from each of the possible offsets
		that are not used */
		/* and the number of possibilities decreases each time we make a choice */
		for (sc = 0; sc<sizeof(Scores)/sizeof(Scores[0]); sc++)
		{
			/* make a choice out of the remaining elements in the array */
			short scchoice = rand()%choicesremain;

			c = 0;

			/* find the actual offset that is available */
			while (c<grid_size)
			{
				/* -1 indicates this offset has already been chosen */
				if (choices[c]!=255)
				{
					if (scchoice==0)
						break;

					scchoice--;
				}
				c++;
			}

			{
				signed short scval = Scores[sc];

				/* found position and store */
				PlayGrid[c] = scval;

				/* say this choice has been made */
				choices[c] = 255;
				/* update number of choices */
				choicesremain--;
			}
		}
	}


/*
	if (CursorX!=0)
	{
		CursorX--;
	}
	else
	{
		CursorX++;
	}

	if (CursorY!=0)
	{
		CursorY--;
	}
	else
	{
		CursorY++;
	}
*/

	printf("*************************************** BEGIN ********************************************\n");

	PlayerId =	(zzz&1)^1;	//0;  1; rand()&1;
	PlayerScores[0] = 0;
	PlayerScores[1] = 0;
	while (1==1)
	{
		int Finish = 0;
	    signed short Score;

		showgrid();


		Finish = DoHardAI();
	    /* get score */
	    Score = PlayGrid[(BestCoords[1]*grid_width)+BestCoords[0]];
	    /* update score */
	    PlayerScores[PlayerId] += (signed int)Score;
	    /* swap player */
	    PlayerId=PlayerId^1;
	    /* now remove */
	    PlayGrid[(BestCoords[1]*grid_width)+BestCoords[0]] = 0;
	    CursorX = BestCoords[0];
	    CursorY = BestCoords[1];


		printf("\nChosen: %d %d (%d)\n", CursorX, CursorY, Score);
		printf("------------------------------------------------------------\n");

		if (Finish)
			break;
	}

	ScoreSummary[(zzz*2)+0] = PlayerScores[0];
	ScoreSummary[(zzz*2)+1] = PlayerScores[1];

	printf("Final Score: %d %d\n", PlayerScores[0], PlayerScores[1]);
	printf("*************************************** END ********************************************\n");

	printf("Done!");
}

p1wins = 0;
p2wins = 0;
printf("\n\nSummary:\n");
for (zzz=0; zzz<NUM_SCORES; zzz++)
{
	printf("%+03d %+03d  ",ScoreSummary[(zzz*2)+0], ScoreSummary[(zzz*2)+1]);
	if (ScoreSummary[(zzz*2)+0]>ScoreSummary[(zzz*2)+1]) { printf("P1"); p1wins++; } else { printf("P2"); p2wins++;}
	printf("\n");
}
printf("P1 Wins: %03d\n", p1wins);
printf("P2 Wins: %03d\n", p2wins);
printf("End Summary\n");

}
