#include "cpcrslib.h"
#include "cpcwyzlib.h"	//Music & Sound library

extern unsigned char SONG_TABLE[];
extern unsigned char EFFECT_TABLE[];
extern unsigned char RULE_TABLE[];
extern unsigned char SOUND_TABLE[];


main(){
	
	
	cpc_ClrScr();
	
	// Text writting using firmware:
	cpc_PrintStr("SFX & MUSIC DEMO. CPCRSLIB 2009");
	cpc_PrintStr("Press keys 1 to 4 to play SFX");
	cpc_PrintStr("ESC to Quit");
	
	cpc_DisableFirmware();	
	// Assign keys to key number (not numberpad keys)
	cpc_AssignKey(0,0x4801);		// key "1" assigned to 0
	cpc_AssignKey(1,0x4802);		// key "2"
	cpc_AssignKey(2,0x4702);		// key "3"
	cpc_AssignKey(3,0x4701);		// key "4"
	
	cpc_AssignKey(4,0x4804);		// key "ESC"
	
	
	cpc_WyzSetBuffer(0x9000);	//sets buffer for uncompressing song
	cpc_WyzInitPlayer(SOUND_TABLE, RULE_TABLE, EFFECT_TABLE, SONG_TABLE);		//initialize data
	cpc_WyzLoadSong(0);	//Select song to play (uncompress it and the start to play)


	cpc_WyzSetPlayerOn();		//start music and sound effects (SFX)

	cpc_ScanKeyboard();			//Reads whole keyboard. It's requiered in order to use cpc_TestKeyF
	while (!cpc_TestKeyF(4)) {	//cpc_TestKeyF is faster when more than 3 keys gonna be tested
		cpc_ScanKeyboard();
		if ((cpc_WyzTestPlayer()&8)==0) {	//test if bit 3 is 0 in order to allow another effect.
			// When a  1-4 key is pressed, a SFX is played
			if (cpc_TestKeyF(0)==1) 	cpc_WyzStartEffect(0,0);	//(Channel, SFX #)
			if (cpc_TestKeyF(1)==1) 	cpc_WyzStartEffect(1,1);
			if (cpc_TestKeyF(2)==1) 	cpc_WyzStartEffect(2,2);
			if (cpc_TestKeyF(3)==1) 	cpc_WyzStartEffect(2,3); 
		} 
	}
	cpc_WyzSetPlayerOff();	//stop music and SFX
	cpc_EnableFirmware();
	return 0;
		
}




// Music Player requiered data
#asm		

._SONG_TABLE 
	DEFW _SONG_0
	
._SONG_0 BINARY "MARIANO3.MUS"			//Song file to be included


._RULE_TABLE
		defw _PAUTA_1
		defw _PAUTA_2
		defw _PAUTA_3
		defw _PAUTA_4


// from *.mus.asm file generated by WYZTracker:

._PAUTA_1	defb	10,12,12,11,10,9,8,7,7,6,6,7,9,9,8,7,7,6,6,7,7,@10000000+4
._PAUTA_2	defb	12,12,11,11,10,10,9,9,8,8,7,7,6,6,7,7,@10000000+4 
._PAUTA_3	defb	7,9,10,9,8,8,7,7,6,6,7,7,6,6,5,5,4,4,3,3,@10000000+8
._PAUTA_4	defb	6,7,7,6,6,5,5,4,4,@10000000+4





._SOUND_TABLE
		defw _SONIDO1
		defw _SONIDO2
		defw _SONIDO3
		defw _SONIDO4
		defw _SONIDO5


// from *.mus.asm file generated by WYZTracker:

._SONIDO1	defb	 $80,$1F,0,$80,$3D,$00,$FF 
._SONIDO2	defb	 $80, $1F, 00, $80, $3F, 00, $D0, $3D, 00, $FF 
._SONIDO3	defb	 $40, $1E, 00, 00, $0A, $02, $FF
._SONIDO4	defb	 $80,$1E, 00, 00, $0A, $08,00, $09, $04, 00, $08, $02, $FF 
._SONIDO5	defb	 00,$09, $04, $FF 




//SFX
/*
SFX format is quite simple:

defb byte1,byte2
defb byte1,byte2
...
defb &ff

Where byte 1 and bits 7, 6, 5 & 4 from byte2 are the sound frequency and bits 3, 2, 1 & 0 of byte2 is the amplitude. 
Effect finishes when &ff is found.
*/

._EFFECT_TABLE
		defw _EFECTO0
		defw _EFECTO1
		defw _EFECTO2
		defw _EFECTO3


._EFECTO0                

defb $58,$0D
defb $50,$0B
defb $47,$0A
defb $3E,$06
defb $35,$03
defb $50,$09
defb $47,$0A
defb $3E,$07
defb $FF

._EFECTO1                

defb $58,$0C
defb $5D,$0D
defb $61,$0E
defb $66,$0F
defb $6A,$0E
defb $6F,$0D
defb $7A,$0C
defb $78,$0B
defb $7C,$0A
defb $85,$09
defb $8E,$08
defb $97,$07
defb $A0,$06
defb $A9,$05
defb $FF


._EFECTO2               

defb $1F,$0B
defb $1A,$0C
defb $1F,$0D
defb $16,$0E
defb $1F,$0E
defb $0D,$0D
defb $1F,$0C
defb $0D,$0B
defb $00,$00
defb $00,$00
defb $1F,$08
defb $1A,$09
defb $1F,$0A
defb $16,$0B
defb $1F,$0B
defb $0D,$0A
defb $1F,$09
defb $0D,$07
defb $00,$00
defb $00,$00
defb $1F,$06
defb $1A,$07
defb $1F,$08
defb $16,$08
defb $1F,$07
defb $0D,$06
defb $1F,$05
defb $FF

._EFECTO3                

defb $1A,$0E
defb $1A,$0E
defb $00,$00
defb $1A,$0A
defb $1A,$0A
defb $00,$00
defb $1A,$0C
defb $1A,$0C
defb $00,$00
defb $1A,$08
defb $1A,$08
defb $FF




#endasm



