XLIB TileMapConf

XDEF tiles
XDEF pantalla_juego
XDEF tiles_tocados
XDEF posiciones_pantalla
XDEF posiciones_super_buffer

XDEF posicion_inicial_area_visible
XDEF posicion_inicial_superbuffer
XDEF ancho_pantalla_bytes
XDEF alto_pantalla_bytes
XDEF ancho_pantalla_bytes_visible


; ***************************************************
; Transparent colour for cpc_PutTrSpTileMap2b routine
XDEF mascara1
XDEF mascara2
; ***************************************************

XDEF tiles_ocultos_ancho0
XDEF tiles_ocultos_alto0
XDEF tiles_ocultos_ancho1
XDEF tiles_ocultos_alto1


XDEF posicion_inicio_pantalla_visible 
XDEF posicion_inicio_pantalla_visible_sb 



;XDEF tile
; ***************************************************
; Scroll Left Addresses column
; not requiered if scroll not used
XDEF ColumnScr
; ***************************************************


; ***************************************************
; Transparent colour for cpc_PutTrSpTileMap2b routine
; For printing sprites using transparent color (mode 0) transparent color selection is requiered. 
; Seleccin color transparente. Escribir las 2 mscaras que correspondan al color elegido.
;Example colour number 7:
defc mascara1 = 0	
defc mascara2 = 0
;0: $00, $00
;1: $80, $40
;2: $04, $08
;3: $44, $88
;4: $10, $20
;5: $50, $A0
;6: $14, $28
;7: $54, $A8
;8: $01, $02
;9: $41, $82
;10: $05, $0A
;11: $45, $8A
;12: $11, $22
;13: $51, $A2
;14: $15, $2A
;15: $55, $AA
; ***************************************************




;------------------------------------------------------------------------------------
; SCREEN AND BUFFER ADDRESSES
; VALORES QUE DEFINEN EL BUFFER Y LA PANTALLA
;------------------------------------------------------------------------------------

defc posicion_inicial_area_visible = $c0AA
defc posicion_inicial_superbuffer = $100
;------------------------------------------------------------------------------------

;------------------------------------------------------------------------------------
; TILE MAP DIMENSIONS
;------------------------------------------------------------------------------------

defc T_WIDTH = 32 			;max=40		;dimensiones de la pantalla en tiles
defc T_HEIGHT = 20			;max=20


;Invisible tile margins:
defc T_WH = 2		
defc T_HH = 0	
;------------------------------------------------------------------------------------


defc tiles_ocultos_ancho0 = T_WH 
defc tiles_ocultos_alto0 = T_HH 
defc tiles_ocultos_ancho1 = T_WIDTH - T_WH - 1
defc tiles_ocultos_alto1 = T_HEIGHT - T_HH - 1

;------------------------------------------------------------------------------------
; Other parameters (internal use)
;------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------

defc ancho_pantalla_bytes = 2*T_WIDTH ; 2*T_WIDTH;		; El ancho de pantalla influye determinantemente en numerosas rutinas que hay que actualizar si se cambia
											; OJO con el modo
defc alto_pantalla_bytes = 8*T_HEIGHT;
defc ancho_pantalla_bytes_visible = 2*T_WIDTH ;32  ; 64;		;dentro del area definida, cuanto se debe mostrar. 2*T_WIDTH

;El tamao del buffer es ancho_pantalla_bytes*alto_pantalla_bytes

.TileMapConf
;------------------------------------------------------------------------------------
;Con la definicin del mapeado hay que tener en cuenta que las coordenadas son:
;ANCHO=64 bytes (128 pixels en modo 0)
;ALTO=128 pixels
;el mximo que entra en el CPC es 20 lneas
;SI NO SE VAN A USAR TODAS LAS LINEAS, PARA AHORRA MEMORIA ES INTERESANTE COMENTARLAS
.posiciones_pantalla		;Posiciones en las que se dibujan los tiles
defw posicion_inicial_area_visible+$50*0
defw posicion_inicial_area_visible+$50*1  
defw posicion_inicial_area_visible+$50*2
defw posicion_inicial_area_visible+$50*3
defw posicion_inicial_area_visible+$50*4
defw posicion_inicial_area_visible+$50*5 
defw posicion_inicial_area_visible+$50*6 
defw posicion_inicial_area_visible+$50*7 
defw posicion_inicial_area_visible+$50*8 
defw posicion_inicial_area_visible+$50*9 
defw posicion_inicial_area_visible+$50*10 
defw posicion_inicial_area_visible+$50*11 
defw posicion_inicial_area_visible+$50*12 
defw posicion_inicial_area_visible+$50*13 
defw posicion_inicial_area_visible+$50*14 
defw posicion_inicial_area_visible+$50*15
defw posicion_inicial_area_visible+$50*16
defw posicion_inicial_area_visible+$50*17
defw posicion_inicial_area_visible+$50*18
defw posicion_inicial_area_visible+$50*19

.posiciones_super_buffer	;muestra el inicio de cada lnea (son 10 tiles de 8x16 de alto)
defw posicion_inicial_superbuffer+8*ancho_pantalla_bytes*0
defw posicion_inicial_superbuffer+8*ancho_pantalla_bytes*1
defw posicion_inicial_superbuffer+8*ancho_pantalla_bytes*2
defw posicion_inicial_superbuffer+8*ancho_pantalla_bytes*3
defw posicion_inicial_superbuffer+8*ancho_pantalla_bytes*4
defw posicion_inicial_superbuffer+8*ancho_pantalla_bytes*5
defw posicion_inicial_superbuffer+8*ancho_pantalla_bytes*6
defw posicion_inicial_superbuffer+8*ancho_pantalla_bytes*7
defw posicion_inicial_superbuffer+8*ancho_pantalla_bytes*8
defw posicion_inicial_superbuffer+8*ancho_pantalla_bytes*9
defw posicion_inicial_superbuffer+8*ancho_pantalla_bytes*10
defw posicion_inicial_superbuffer+8*ancho_pantalla_bytes*11
defw posicion_inicial_superbuffer+8*ancho_pantalla_bytes*12
defw posicion_inicial_superbuffer+8*ancho_pantalla_bytes*13
defw posicion_inicial_superbuffer+8*ancho_pantalla_bytes*14
defw posicion_inicial_superbuffer+8*ancho_pantalla_bytes*15
defw posicion_inicial_superbuffer+8*ancho_pantalla_bytes*16
defw posicion_inicial_superbuffer+8*ancho_pantalla_bytes*17
defw posicion_inicial_superbuffer+8*ancho_pantalla_bytes*18
defw posicion_inicial_superbuffer+8*ancho_pantalla_bytes*19




; ***************************************************
; Scroll Left Addresses column
; not requiered if scroll not used comment it ;)
.ColumnScr
defw $C0AA
defw $C8AA
defw $D0AA
defw $D8AA
defw $E0AA
defw $E8AA
defw $F0AA
defw $F8AA
defw $C0FA
defw $C8FA
defw $D0FA
defw $D8FA
defw $E0FA
defw $E8FA
defw $F0FA
defw $F8FA
defw $C14A
defw $C94A
defw $D14A
defw $D94A
defw $E14A
defw $E94A
defw $F14A
defw $F94A
defw $C19A
defw $C99A
defw $D19A
defw $D99A
defw $E19A
defw $E99A
defw $F19A
defw $F99A
defw $C1EA
defw $C9EA
defw $D1EA
defw $D9EA
defw $E1EA
defw $E9EA
defw $F1EA
defw $F9EA
defw $C23A
defw $CA3A
defw $D23A
defw $DA3A
defw $E23A
defw $EA3A
defw $F23A
defw $FA3A
defw $C28A
defw $CA8A
defw $D28A
defw $DA8A
defw $E28A
defw $EA8A
defw $F28A
defw $FA8A
defw $C2DA
defw $CADA
defw $D2DA
defw $DADA
defw $E2DA
defw $EADA
defw $F2DA
defw $FADA
defw $C32A
defw $CB2A
defw $D32A
defw $DB2A
defw $E32A
defw $EB2A
defw $F32A
defw $FB2A
defw $C37A
defw $CB7A
defw $D37A
defw $DB7A
defw $E37A
defw $EB7A
defw $F37A
defw $FB7A
defw $C3CA
defw $CBCA
defw $D3CA
defw $DBCA
defw $E3CA
defw $EBCA
defw $F3CA
defw $FBCA
defw $C41A
defw $CC1A
defw $D41A
defw $DC1A
defw $E41A
defw $EC1A
defw $F41A
defw $FC1A
defw $C46A
defw $CC6A
defw $D46A
defw $DC6A
defw $E46A
defw $EC6A
defw $F46A
defw $FC6A
defw $C4BA
defw $CCBA
defw $D4BA
defw $DCBA
defw $E4BA
defw $ECBA
defw $F4BA
defw $FCBA
defw $C50A
defw $CD0A
defw $D50A
defw $DD0A
defw $E50A
defw $ED0A
defw $F50A
defw $FD0A
defw $C55A
defw $CD5A
defw $D55A
defw $DD5A
defw $E55A
defw $ED5A
defw $F55A
defw $FD5A
defw $C5AA
defw $CDAA
defw $D5AA
defw $DDAA
defw $E5AA
defw $EDAA
defw $F5AA
defw $FDAA
defw $C5FA
defw $CDFA
defw $D5FA
defw $DDFA
defw $E5FA
defw $EDFA
defw $F5FA
defw $FDFA
; ***************************************************


.pantalla_actual defw 0
.pantalla_juego  ;en tiles
defs T_WIDTH*T_HEIGHT
defb $FF	;Este byte es importante, marca el fin de la pantalla.
.tiles_tocados defs 250 ;150	;cuando un tile es tocado, se marca en esta tabla para luego restaurarlo. Es una tabla sin duplicados.

;------------------------------------------------------------------------------------
; TILE DATA. TILES MUST BE DEFINED HERE
;------------------------------------------------------------------------------------
	

.tiles ;Son de 2x8 bytes
defb $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
defb $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
defb $FF,$77,$FF,$DF,$FF,$F7,$73,$E7,$FF,$F7,$FF,$DF,$FF,$77,$FF,$FF
defb $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$BF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
defb $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$30
defb $FF,$FF,$FF,$F7,$FF,$7F,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
defb $FF,$FF,$FF,$FF,$FF,$FF,$BA,$FF,$FA,$FF,$FF,$FF,$FF,$FF,$FF,$FF
defb $FF,$FD,$FF,$FD,$FF,$7D,$BC,$BC,$FF,$7D,$FF,$FD,$FF,$FF,$FF,$FF
defb $FF,$FF,$FF,$FA,$FF,$9A,$FF,$DB,$BA,$6F,$BA,$B5,$EF,$B0,$EF,$F0
defb $FF,$FF,$30,$FF,$30,$75,$30,$75,$B0,$DD,$CC,$30,$30,$B8,$30,$30
defb $FF,$FF,$FF,$F7,$FB,$37,$FB,$3F,$BB,$3F,$FF,$7F,$FF,$FF,$FF,$FF
defb $FF,$FF,$FF,$BB,$FF,$BF,$FF,$73,$FF,$F3,$BB,$9B,$BF,$33,$BF,$33
defb $73,$3F,$B3,$37,$73,$37,$3B,$37,$37,$3F,$F3,$37,$33,$3F,$33,$37
defb $FF,$FF,$7F,$FF,$7F,$FF,$9D,$FF,$3F,$FF,$3F,$7F,$3F,$DD,$3F,$FF
defb $EF,$DD,$E7,$4C,$A6,$9D,$EE,$7F,$FF,$FF,$DF,$7F,$6E,$FF,$1D,$FF
defb $8E,$1D,$F7,$B7,$FF,$DD,$E6,$FF,$F3,$EE,$CE,$DD,$3F,$DD,$3F,$DD
defb $FF,$E7,$FB,$8E,$BF,$0C,$FF,$BF,$FB,$DF,$E7,$1D,$CF,$8E,$EF,$1D
defb $CA,$E7,$CF,$DB,$E7,$B7,$1D,$3F,$AE,$3F,$BF,$3F,$FF,$CC,$FF,$FF
defb $E6,$FF,$E6,$7F,$FB,$DD,$EE,$FF,$FF,$FB,$DD,$E6,$7F,$A6,$FF,$EE
defb $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FA,$FF,$FA,$FF,$EF,$FF,$EF,$FF,$B0
defb $FA,$30,$B0,$9A,$DF,$FF,$75,$75,$BA,$FF,$BA,$FF,$BA,$FF,$BA,$FF
defb $75,$FF,$DF,$30,$30,$BA,$EF,$BA,$FA,$BA,$FF,$30,$FF,$DF,$FF,$DF
defb $FF,$FF,$FF,$FF,$F5,$FF,$F0,$FF,$F0,$DF,$F0,$DF,$70,$CF,$30,$E5
defb $FF,$FF,$FF,$FF,$FF,$FF,$FF,$B3,$FB,$39,$FF,$79,$7D,$BE,$3C,$FF
defb $FF,$FF,$FF,$FF,$FF,$FF,$7F,$BF,$B3,$99,$F3,$6E,$39,$33,$FF,$FF
defb $FF,$FF,$FF,$FF,$FF,$FF,$F3,$6E,$79,$E6,$36,$F3,$CC,$79,$FF,$FF
defb $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$7F,$FF,$3F,$FF,$EE,$DD
defb $FA,$9A,$BA,$F0,$BF,$E5,$FF,$7A,$FF,$35,$FF,$BA,$FF,$FF,$FF,$FF
defb $30,$30,$30,$30,$B0,$64,$30,$DD,$CC,$75,$B0,$FF,$FF,$FF,$FF,$FF
defb $AF,$FF,$3F,$7F,$4E,$DD,$3F,$7F,$AF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
defb $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$BB,$FF,$B7,$FF,$3F,$FF,$BF
defb $BB,$3F,$BB,$33,$FF,$B3,$FF,$73,$FF,$BF,$7F,$BB,$7F,$FF,$FF,$FF
defb $33,$3F,$3F,$6E,$33,$3F,$33,$3F,$33,$37,$3F,$6E,$73,$3F,$FF,$FF
defb $DD,$7F,$3F,$7F,$3F,$FF,$3F,$FF,$7F,$FF,$DD,$FF,$FF,$FF,$FF,$FF
defb $7F,$8C,$FF,$FF,$EF,$F7,$CF,$E2,$CF,$E2,$F3,$C0,$D9,$95,$EA,$6A
defb $FE,$FC,$FE,$FC,$FE,$7C,$FE,$7C,$FE,$7C,$FE,$3C,$FE,$7C,$FF,$7D
defb $FC,$FC,$FC,$FC,$FC,$FC,$BC,$FC,$BC,$FC,$3C,$FC,$FC,$FC,$FF,$FF
defb $FF,$B0,$FF,$DF,$FF,$DF,$FF,$DF,$FF,$75,$BA,$75,$BA,$75,$FA,$BA
defb $BA,$FF,$75,$FF,$75,$FF,$75,$FF,$75,$FF,$75,$FF,$75,$FF,$FF,$FF
defb $FF,$DF,$FF,$75,$FF,$75,$FF,$30,$FF,$EF,$FF,$EF,$FF,$38,$BE,$BE
defb $30,$F0,$70,$F0,$30,$F0,$BA,$70,$BA,$70,$BA,$30,$BA,$30,$BA,$30
defb $F5,$FF,$F5,$FF,$F0,$FF,$F0,$FF,$70,$F5,$70,$F5,$30,$F5,$30,$F0
defb $73,$BF,$77,$7B,$77,$73,$37,$B3,$77,$B7,$7F,$37,$7D,$37,$7D,$6E
defb $B7,$6E,$37,$3B,$3F,$3B,$3F,$3F,$6E,$9D,$3B,$CC,$3B,$37,$3F,$73
defb $FF,$CC,$DD,$7B,$CC,$7B,$B7,$9D,$B3,$3F,$3F,$6E,$9D,$7F,$FF,$CC
defb $F3,$3F,$B7,$3F,$37,$3F,$B3,$6E,$99,$6E,$9D,$99,$66,$BB,$B7,$DD
defb $37,$6E,$6E,$3F,$6E,$9D,$37,$EE,$3F,$99,$37,$33,$37,$66,$66,$6E
defb $7F,$FF,$3F,$FF,$9D,$7F,$9D,$7F,$73,$3F,$B7,$3F,$B7,$3F,$37,$3F
defb $FF,$FB,$FF,$EF,$FF,$EF,$FF,$F3,$FF,$DB,$FF,$9B,$FB,$B3,$FB,$9B
defb $0C,$3F,$BF,$7F,$BF,$FF,$FF,$FF,$FF,$8E,$EF,$CF,$EF,$E7,$CA,$F3
defb $FE,$7C,$FE,$DC,$FE,$AD,$FB,$AD,$FB,$FC,$FB,$FD,$FB,$F6,$EF,$F3
defb $FC,$FC,$FC,$FC,$5E,$FF,$5E,$FC,$FC,$FC,$FC,$FE,$FC,$FC,$FC,$FC
defb $AB,$03,$AB,$A9,$AB,$03,$AB,$03,$AB,$03,$AB,$03,$AB,$A9,$AB,$03
defb $43,$C3,$57,$EB,$56,$57,$03,$57,$03,$03,$03,$03,$03,$03,$03,$03
defb $C3,$3F,$6B,$3F,$C3,$97,$97,$97,$EB,$97,$EB,$97,$57,$97,$FD,$C3
defb $7F,$FB,$FF,$FF,$CF,$FF,$DB,$DD,$E2,$F7,$CA,$D5,$CF,$C4,$C0,$6E
defb $EF,$BA,$EF,$BA,$EF,$BA,$FA,$BA,$BA,$BA,$B0,$BA,$F5,$75,$DF,$75
defb $BE,$57,$BE,$43,$BE,$EB,$BE,$DD,$BE,$8D,$BE,$8D,$BE,$AF,$FF,$7D
defb $38,$30,$FE,$30,$56,$30,$56,$30,$FE,$30,$DC,$30,$DC,$30,$DC,$30
defb $30,$F0,$30,$70,$30,$70,$30,$70,$30,$70,$30,$30,$30,$30,$30,$30
defb $FF,$FF,$FF,$FF,$F5,$FF,$F5,$FF,$F5,$FF,$F5,$FF,$F5,$FF,$F0,$FF
defb $BB,$6E,$FB,$6E,$BB,$D9,$BF,$D9,$7F,$3B,$3F,$3B,$B7,$BF,$7B,$7F
defb $37,$EE,$B7,$7F,$37,$6E,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$6E,$FF,$FF
defb $9D,$DD,$CC,$BF,$EE,$99,$99,$CC,$D9,$6E,$D9,$37,$EE,$B7,$FF,$FF
defb $9D,$6E,$9D,$CC,$6E,$BF,$CC,$66,$BB,$B7,$99,$B7,$DD,$3F,$FF,$FF
defb $99,$B7,$73,$3F,$73,$3F,$99,$B7,$9D,$77,$CC,$7F,$6E,$FF,$FF,$FF
defb $FF,$FF,$FF,$FF,$FF,$BE,$FF,$3C,$BE,$39,$EF,$3C,$B6,$33,$39,$3B
defb $BB,$6E,$FB,$6E,$BB,$D9,$BF,$D9,$FF,$3B,$FF,$3B,$FF,$BF,$FF,$FF
defb $FF,$AF,$FF,$6C,$BE,$4E,$BE,$4E,$3C,$85,$79,$A7,$2D,$E2,$D1,$0F
defb $DD,$FF,$CC,$FF,$CC,$DD,$CC,$DD,$CC,$CC,$4E,$CC,$4E,$CC,$0F,$CC
defb $FF,$FF,$FF,$FF,$FF,$FF,$5D,$FF,$FF,$5D,$FF,$FF,$FF,$FF,$AE,$FF
defb $AB,$03,$AB,$03,$AB,$03,$AB,$A9,$AB,$03,$AB,$03,$AB,$03,$AB,$03
defb $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03
defb $57,$97,$57,$C3,$03,$EB,$03,$EB,$56,$BF,$57,$BF,$EB,$BF,$BE,$C3
defb $AE,$1D,$CC,$3F,$EE,$FF,$FF,$FB,$FF,$E7,$DF,$EF,$A6,$FF,$F3,$FF
defb $FF,$FF,$BF,$DD,$F7,$6F,$F3,$6F,$CE,$FF,$FF,$5D,$AE,$E6,$EE,$F7
defb $FF,$FF,$DF,$EE,$E6,$EF,$E6,$7B,$9D,$6E,$EF,$5D,$3F,$F7,$FF,$7F
defb $DF,$75,$DF,$75,$F5,$75,$75,$75,$75,$75,$30,$EE,$75,$CC,$FF,$CC
defb $FF,$FE,$FF,$FF,$FF,$FA,$FF,$EF,$FF,$EF,$FF,$EF,$FF,$FA,$FF,$BA
defb $FE,$30,$FD,$30,$FF,$30,$75,$30,$75,$30,$75,$30,$75,$30,$75,$30
defb $30,$30,$30,$30,$30,$30,$30,$30,$30,$30,$30,$30,$30,$30,$30,$30
defb $70,$EE,$70,$8C,$70,$EE,$70,$EE,$70,$FF,$F0,$F5,$F0,$F5,$F0,$F5
defb $BB,$9B,$BF,$CF,$BF,$67,$6F,$3F,$9E,$E6,$9B,$67,$B3,$33,$33,$3F
defb $FF,$FF,$FF,$FF,$7F,$FF,$66,$FF,$3F,$DD,$37,$7F,$37,$CC,$3F,$CC
defb $FF,$DF,$FF,$FF,$FF,$FF,$EF,$FF,$FF,$EF,$FF,$FF,$FF,$FF,$FF,$FF
defb $D1,$0F,$4A,$0F,$0F,$0F,$0F,$0F,$AF,$8F,$AF,$0F,$FF,$4E,$FF,$EE
defb $0F,$CC,$0F,$CC,$0E,$CC,$4E,$CC,$4E,$DD,$CC,$DD,$CC,$FF,$DD,$FF
defb $9D,$7F,$3F,$7F,$7F,$FF,$FF,$CF,$FB,$DB,$EF,$CF,$FF,$CF,$FB,$DB
defb $AB,$03,$AB,$A9,$AB,$03,$AB,$03,$AB,$03,$AB,$03,$AB,$03,$AB,$A9
defb $BE,$C3,$EB,$EB,$57,$BF,$56,$BF,$03,$EB,$03,$EB,$57,$C3,$FD,$C3
defb $DD,$EE,$E6,$FF,$A6,$FB,$7F,$D9,$FF,$AE,$FF,$FF,$FB,$DF,$E7,$8E
defb $E6,$FF,$E7,$FF,$8E,$7F,$CC,$7F,$9D,$FF,$3F,$FB,$FF,$CF,$FF,$E7
defb $FF,$F7,$FB,$E6,$EF,$E6,$FF,$5D,$F7,$FF,$1D,$FB,$9D,$EF,$7F,$FF
defb $FF,$FF,$7F,$FF,$FF,$EF,$6F,$FF,$EE,$F7,$FF,$B7,$7F,$3F,$DD,$BF
defb $FF,$BA,$FF,$BA,$FF,$FA,$FF,$EF,$FF,$EF,$FF,$EF,$FF,$EF,$FF,$EF
defb $75,$30,$75,$30,$75,$30,$75,$30,$75,$30,$75,$30,$75,$30,$75,$30
defb $70,$F5,$70,$F5,$30,$F0,$30,$F0,$70,$F0,$70,$F0,$70,$30,$30,$30
defb $FF,$FF,$FF,$EE,$EE,$FB,$FB,$EE,$F3,$DD,$E6,$DD,$EE,$DD,$EE,$FF
defb $FF,$FF,$EE,$FF,$E6,$DD,$EE,$DD,$FF,$FB,$FF,$EF,$DD,$EF,$DD,$EF
defb $FB,$CE,$EF,$9E,$E7,$67,$9B,$73,$9B,$33,$B3,$33,$33,$37,$33,$3F
defb $FB,$3F,$FB,$3F,$FF,$B7,$FF,$6E,$FF,$FB,$FF,$7B,$BF,$9D,$BF,$6E
defb $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$7F,$FF,$6E,$FF,$EE,$DD
defb $A6,$5D,$2E,$7F,$3F,$DD,$3F,$DD,$6E,$DD,$CC,$FF,$BF,$77,$FF,$FF
defb $AB,$03,$AB,$03,$AB,$03,$AB,$03,$AB,$03,$AB,$A9,$AB,$03,$FF,$FF
defb $03,$03,$03,$03,$03,$03,$03,$57,$56,$57,$57,$EB,$43,$C3,$FF,$FF
defb $57,$C3,$EB,$97,$EB,$3F,$C3,$3F,$C3,$6B,$97,$3F,$6B,$6B,$FF,$FF
defb $E7,$DD,$DB,$1D,$59,$9D,$CC,$7F,$EE,$FF,$FF,$FB,$7F,$E7,$5D,$A6
defb $FF,$FF,$FF,$DF,$FB,$DF,$FB,$4C,$FF,$5D,$DD,$EE,$E6,$FB,$DF,$9D
defb $EE,$FF,$FB,$DD,$E7,$5D,$AE,$FF,$FF,$FF,$DD,$EF,$DD,$DB,$FF,$AE
defb $FB,$FF,$E7,$DD,$AE,$DD,$DF,$FB,$5D,$FB,$6E,$FF,$6E,$EE,$DD,$DF
defb $DD,$BA,$DD,$FA,$FF,$FA,$EE,$FA,$CC,$FA,$CC,$98,$EE,$DD,$EE,$DD
defb $30,$30,$30,$30,$30,$30,$30,$30,$30,$30,$30,$30,$30,$75,$FF,$EE
defb $30,$30,$30,$30,$30,$30,$30,$30,$30,$BA,$75,$DD,$FF,$CC,$EE,$CC
defb $DD,$BE,$CC,$BE,$EE,$BB,$FF,$BB,$DD,$BE,$DD,$BE,$FF,$BE,$EE,$BF
defb $FB,$FF,$A6,$DD,$B7,$5D,$EE,$DD,$FF,$FF,$FF,$FF,$DD,$F7,$FB,$9F
defb $6E,$FB,$6E,$FB,$7F,$BB,$CC,$CC,$BB,$6E,$B7,$6E,$B7,$6E,$37,$6E
defb $CC,$3F,$33,$3F,$B7,$7F,$B7,$7F,$9D,$FF,$3F,$7F,$3F,$3F,$3B,$B7
defb $F7,$FF,$DD,$DD,$FF,$5D,$FF,$4C,$BF,$5D,$AE,$CC,$AE,$CC,$FF,$AE
defb $3B,$6E,$7F,$6E,$7F,$D9,$FF,$D9,$FF,$3B,$FF,$3B,$FF,$BF,$FF,$FF
defb $BF,$A6,$DD,$7F,$5D,$FF,$FF,$CF,$FB,$D9,$EF,$CD,$EE,$CD,$EE,$CC
defb $CC,$73,$9D,$3B,$DD,$3F,$B7,$BF,$3F,$EE,$3F,$EE,$6E,$99,$CC,$EE
defb $FF,$BF,$FF,$7B,$FF,$73,$BF,$B3,$BB,$B7,$BB,$37,$BF,$37,$BB,$6E
defb $FF,$DD,$CC,$F7,$DD,$DD,$DD,$FB,$FF,$E7,$FF,$A6,$DD,$EE,$DD,$FF
defb $FB,$1D,$FF,$CC,$F7,$EE,$CF,$FF,$8E,$DD,$59,$DD,$4C,$FF,$CC,$FF
defb $FF,$E6,$FB,$E7,$FF,$A6,$FF,$EE,$DB,$FF,$CF,$DD,$A6,$6E,$1D,$3F
defb $FF,$BE,$FF,$BE,$FF,$BB,$FF,$BB,$FF,$BE,$FF,$BE,$FF,$BE,$FF,$BF
defb $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$BB
defb $FF,$FB,$FF,$B3,$BB,$B3,$BB,$33,$33,$33,$33,$33,$37,$3B,$33,$3F
defb $33,$FF,$33,$3F,$37,$3F,$37,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F
defb $FF,$FF,$FF,$FF,$7F,$BF,$3F,$FF,$3F,$CC,$3F,$CC,$3F,$6E,$3F,$6E
defb $FF,$FF,$3F,$FF,$B7,$7F,$3F,$3F,$BF,$3F,$DD,$BF,$CC,$FF,$CC,$DD
defb $FF,$FF,$FF,$FF,$FF,$FF,$DD,$FF,$CC,$3F,$6E,$3F,$6E,$6E,$EE,$9D
defb $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$DD,$FF,$CC,$DD,$CC,$CC,$CC,$CC
defb $DB,$37,$DB,$37,$B3,$3F,$37,$3F,$37,$3F,$3F,$3F,$3F,$3F,$37,$3F
defb $6E,$CC,$6E,$CC,$6E,$CC,$3F,$CC,$3F,$6E,$3F,$6E,$3F,$6E,$3F,$6E
defb $DD,$FF,$DD,$FF,$DD,$FF,$CC,$FF,$CC,$FF,$CC,$FF,$CC,$DD,$CC,$DD
defb $FF,$FF,$FF,$FF,$FF,$FF,$EE,$CC,$CC,$CC,$CC,$DD,$CC,$DD,$FF,$FF
defb $FF,$FF,$FF,$FF,$FF,$FF,$F7,$FF,$9D,$7F,$BF,$7B,$CC,$6E,$FF,$FF
defb $FF,$BB,$FF,$BB,$FF,$33,$FF,$33,$FF,$33,$BB,$33,$33,$BB,$77,$FF
defb $33,$3F,$33,$37,$33,$33,$33,$33,$33,$33,$33,$33,$33,$33,$BB,$BB
defb $3F,$3F,$3F,$3F,$33,$3F,$33,$37,$33,$37,$33,$37,$33,$3F,$37,$7F
defb $3F,$CC,$6E,$CC,$CC,$CC,$3F,$6E,$3F,$3F,$3F,$3F,$3F,$3F,$7F,$3F
defb $CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$6E,$DD,$EE,$DD
defb $FF,$CC,$DD,$EE,$CC,$FF,$CC,$DD,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$DD
defb $6E,$CC,$CC,$CC,$CC,$CC,$FF,$6E,$DD,$EE,$9D,$7F,$CC,$9D,$FF,$FF
defb $DD,$FF,$CC,$FF,$CC,$DD,$CC,$CC,$CC,$DD,$FF,$FF,$7F,$BF,$FF,$FF
defb $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$BF,$FF,$EF,$FF,$9C
defb $37,$3F,$33,$3F,$DB,$37,$73,$5C,$99,$37,$66,$9D,$73,$37,$33,$33
defb $3F,$6E,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$6E,$3F,$3F,$3F,$3F
defb $CC,$DD,$CC,$DD,$CC,$DD,$6E,$FF,$6E,$CC,$CC,$CC,$CC,$6E,$6E,$CC
defb $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$DD,$FF,$DD,$FF,$DD,$FF
defb $FF,$FF,$DF,$DD,$5D,$FF,$A6,$EF,$DD,$FF,$FF,$5D,$EF,$E6,$EE,$F7
defb $FF,$FF,$5D,$FB,$5D,$E6,$DD,$E7,$FF,$EF,$FB,$7F,$D9,$7F,$EE,$7F
defb $FF,$F7,$EF,$4C,$FF,$5D,$DD,$FF,$BF,$E6,$EE,$A6,$9D,$5D,$BF,$FF
defb $FF,$DF,$EF,$F7,$FB,$4C,$FB,$AE,$FF,$5D,$6E,$A6,$DD,$F7,$BF,$FF
defb $FF,$FF,$FF,$F7,$AE,$7F,$FB,$DD,$EE,$AE,$FF,$D9,$FF,$BF,$EE,$DF
defb $FF,$FF,$FB,$FF,$7B,$5D,$A6,$FF,$EE,$FF,$5D,$FB,$F7,$E6,$FF,$EE
defb $FF,$FF,$FB,$BF,$A6,$FF,$B7,$5D,$BF,$7F,$FF,$FF,$DD,$DD,$FF,$FF
defb $FF,$B6,$FF,$DB,$DD,$9B,$FF,$9B,$FF,$E2,$FF,$BE,$FF,$FB,$FF,$E6
defb $37,$3F,$37,$3F,$37,$3F,$33,$3F,$33,$3F,$33,$3F,$39,$37,$F3,$37
defb $3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F
defb $6E,$CC,$3F,$CC,$3F,$CC,$3F,$6E,$3F,$6E,$3F,$3F,$3F,$3F,$3F,$3F
defb $CC,$EE,$6E,$AE,$3F,$FF,$9D,$FF,$CC,$DD,$CC,$DD,$CC,$DD,$CC,$DD
defb $FF,$FF,$F7,$FB,$5D,$0C,$FF,$EE,$FB,$FF,$CD,$77,$CC,$FF,$FF,$FF
defb $FF,$FF,$EF,$EE,$FB,$4C,$FF,$F7,$DF,$FF,$4C,$FB,$BF,$AE,$FF,$FF
defb $EF,$FF,$DB,$CC,$AE,$E6,$FF,$7F,$DF,$FF,$E6,$EF,$1D,$FB,$BF,$FF
defb $DF,$FF,$4C,$EF,$2E,$BF,$FF,$FF,$F7,$DD,$1D,$FF,$9D,$FB,$FF,$FF
defb $FF,$FF,$FF,$F7,$EF,$7F,$FB,$4C,$BF,$4C,$FF,$DD,$EB,$FF,$EB,$EB
defb $FF,$FF,$FF,$FF,$7F,$F7,$FB,$9F,$FB,$4C,$BF,$0C,$D7,$DD,$43,$FF
defb $FF,$FF,$FB,$DD,$CD,$5D,$BF,$0C,$7F,$6E,$AB,$DD,$AB,$FF,$C3,$43
defb $FF,$FF,$FF,$FF,$7F,$F7,$EF,$4C,$FB,$4C,$7F,$DD,$EB,$EB,$C3,$03
defb $FF,$4C,$DD,$DD,$DD,$FF,$FF,$B3,$FB,$39,$FF,$79,$7D,$BE,$3C,$FF
defb $FB,$CC,$EE,$5D,$FF,$FF,$7F,$BF,$B3,$99,$F3,$6E,$39,$33,$FF,$FF
defb $A6,$DD,$FF,$FF,$FF,$FF,$F3,$6E,$79,$E6,$36,$F3,$CC,$79,$FF,$FF
defb $FF,$FF,$DD,$FB,$3F,$FB,$7F,$D9,$7F,$EE,$FF,$FF,$EF,$F7,$EF,$8E
defb $FF,$FF,$EF,$DD,$EE,$E6,$F7,$DD,$DD,$FB,$CC,$EF,$5D,$9F,$FF,$EE
defb $DD,$AE,$FF,$FF,$FF,$F7,$EE,$5D,$EE,$FF,$FF,$FB,$DD,$DB,$DD,$AE
defb $FF,$FF,$EF,$EE,$DB,$FB,$3F,$EE,$AE,$FF,$FF,$CC,$F7,$A6,$DD,$F7
defb $DD,$FF,$CE,$EF,$E6,$FB,$B7,$FB,$7F,$FF,$FF,$DF,$EF,$F7,$FF,$A6
defb $DD,$DD,$DD,$EF,$CE,$FB,$59,$BF,$F3,$FF,$FF,$7F,$BF,$A6,$FF,$1D
defb $DF,$FF,$D9,$BF,$E6,$EF,$4C,$FB,$7F,$FF,$FF,$F7,$FB,$6E,$FF,$7F
defb $DD,$EF,$F7,$6E,$6E,$B7,$7F,$2E,$7F,$FF,$EF,$FF,$BF,$DF,$FB,$5D
defb $BF,$BF,$7F,$6E,$DD,$7B,$FB,$E6,$FF,$4C,$AE,$FF,$A6,$F7,$5D,$FF
defb $FF,$EF,$DD,$CE,$7F,$DB,$FF,$A6,$FB,$FB,$8E,$7F,$F3,$7F,$5D,$EE
defb $EF,$4C,$EE,$A6,$7F,$F7,$6E,$FF,$E6,$FB,$DD,$EF,$FF,$EE,$EF,$F7
defb $D9,$B3,$CC,$D9,$33,$E6,$9B,$33,$73,$B3,$33,$33,$3B,$33,$3F,$3F
defb $37,$3F,$B3,$3F,$D9,$B7,$73,$F3,$33,$3F,$9B,$33,$37,$3F,$3F,$3F
defb $3F,$3F,$3F,$3F,$3F,$6E,$3F,$CC,$6E,$CC,$3F,$CC,$3F,$CC,$3F,$6E
defb $CC,$DD,$CC,$EE,$FF,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$3F,$9D,$3F,$CC
defb $FF,$CD,$DD,$D9,$CC,$EE,$CC,$FF,$CC,$FF,$CC,$DD,$CC,$DD,$CC,$DD
defb $F7,$FF,$DD,$5F,$FF,$5F,$FF,$4E,$AF,$5F,$AF,$CC,$AF,$CC,$FF,$8D
defb $FF,$FF,$DD,$5F,$DD,$DD,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$AF,$DD
defb $AF,$FF,$8D,$FF,$8D,$EE,$EE,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
defb $FF,$EE,$DD,$E6,$EE,$EF,$EE,$FF,$FF,$FF,$FF,$AF,$FF,$4E,$5F,$5F
defb $83,$C3,$AB,$C3,$EB,$C3,$EB,$C3,$83,$C3,$03,$C3,$AB,$C3,$EB,$C3
defb $C3,$C3,$C3,$C3,$C3,$C3,$C3,$C3,$C3,$C3,$C3,$C3,$C3,$C3,$C3,$C3
defb $C3,$C3,$C3,$C3,$D6,$C3,$A9,$C3,$A9,$C3,$03,$43,$83,$C3,$C3,$C3
defb $C3,$C3,$C3,$C3,$D6,$C3,$C3,$C3,$C3,$C3,$C3,$C3,$C3,$C3,$C3,$C3
defb $C3,$57,$C3,$57,$C3,$57,$C3,$03,$C3,$83,$C3,$83,$C3,$83,$C3,$57
defb $DD,$CC,$DD,$9D,$DD,$9D,$DD,$EE,$FF,$EE,$FF,$EE,$EE,$FF,$FF,$FF
defb $BF,$FF,$2E,$FF,$B7,$2E,$DD,$FB,$FB,$FF,$F3,$5D,$73,$FB,$BF,$FB
defb $EE,$FF,$8E,$FB,$9F,$DD,$BF,$DD,$FF,$DD,$5D,$EF,$9F,$EF,$3F,$EE
defb $DF,$FF,$F3,$7F,$8C,$FF,$5D,$7F,$FF,$FF,$E6,$EF,$1D,$FF,$7F,$FF
defb $FF,$BF,$FB,$9D,$F3,$CC,$FF,$A6,$F7,$FF,$8E,$FF,$3F,$AE,$7F,$FF
defb $EF,$7B,$BF,$CE,$FF,$DD,$FF,$FF,$FF,$EF,$5D,$DB,$7F,$2E,$DD,$AE
defb $FF,$CF,$DD,$9B,$DD,$9B,$FF,$9B,$FF,$9B,$FB,$33,$FB,$33,$EF,$33
defb $37,$3B,$37,$3B,$37,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$37,$3F
defb $3F,$3F,$B3,$3F,$37,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F
defb $9D,$6E,$9D,$CC,$6E,$CC,$6E,$CC,$3F,$CC,$3F,$9D,$3F,$CC,$3F,$CC
defb $CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$DD,$6E,$EE,$6E,$CC
defb $DD,$8D,$DD,$0F,$DD,$1F,$DD,$AF,$FF,$AF,$FF,$AF,$EE,$FF,$FF,$FF
defb $0F,$DD,$0F,$9D,$4E,$CC,$4E,$CC,$CC,$CC,$CC,$DD,$CC,$FF,$EE,$DD
defb $4E,$EE,$4E,$FF,$0F,$FF,$8D,$FF,$8D,$5F,$CC,$5F,$CC,$DD,$CC,$DD
defb $5F,$CD,$5F,$D9,$0F,$EE,$8D,$FF,$8D,$FF,$8D,$DD,$CC,$DD,$CC,$DD
defb $EB,$C3,$43,$C3,$43,$C3,$AB,$C3,$AB,$C3,$43,$C3,$43,$C3,$C3,$C3
defb $83,$C3,$43,$43,$C3,$03,$C3,$43,$83,$43,$83,$03,$C3,$43,$C3,$C3
defb $43,$C3,$43,$C3,$83,$C3,$83,$C3,$83,$D6,$03,$FC,$56,$FD,$43,$FD
defb $C3,$C3,$C3,$FF,$D7,$FF,$D7,$BB,$FF,$33,$BB,$33,$BF,$33,$37,$33
defb $FF,$FF,$FF,$FF,$BB,$33,$73,$B3,$73,$F3,$33,$B3,$33,$33,$3B,$33
defb $FF,$FF,$FF,$FF,$37,$3F,$33,$3F,$37,$3F,$3F,$3F,$3F,$3F,$3F,$3F
defb $C3,$C3,$FF,$C3,$FF,$EB,$3F,$EB,$3F,$7F,$3F,$7F,$3F,$3F,$6E,$3F
defb $C3,$C3,$C3,$C3,$C3,$C3,$C3,$C3,$C3,$C3,$C3,$C3,$EB,$C3,$EB,$C3
defb $C3,$C3,$C3,$C3,$C3,$83,$C3,$D7,$C3,$D7,$C3,$C3,$C3,$C3,$C3,$83
defb $FF,$FF,$F7,$FB,$8E,$FB,$B7,$FF,$3F,$FF,$7F,$E6,$FF,$E7,$FB,$8E
defb $EF,$B3,$BB,$9B,$DD,$73,$FF,$BB,$EE,$FF,$E6,$DD,$E6,$DD,$FB,$FF
defb $37,$3F,$33,$3F,$9B,$33,$67,$33,$33,$67,$FF,$33,$CC,$FF,$CC,$FF
defb $3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$33,$3F,$33,$33,$FF,$33,$DD,$FF
defb $3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$33,$37,$33,$33,$33,$33
defb $3F,$3F,$3F,$3F,$3F,$3F,$3F,$CC,$3F,$6E,$3F,$6E,$3F,$3F,$3F,$7F
defb $6E,$9D,$6E,$9D,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$FF,$FF,$FF,$FF,$DD
defb $CC,$DD,$CC,$FF,$CC,$FF,$DD,$FF,$FF,$F7,$FB,$CE,$FB,$5D,$FF,$DD
defb $C3,$D7,$E9,$D7,$C3,$FD,$C3,$FD,$D6,$83,$C3,$83,$C3,$E9,$C3,$C3
defb $BB,$37,$99,$37,$FF,$DD,$EE,$6E,$AE,$6E,$AE,$3F,$57,$1D,$03,$FF
defb $33,$37,$33,$3B,$BB,$3B,$FF,$FF,$EE,$6E,$DD,$4C,$DD,$DD,$AB,$AB
defb $3F,$9D,$3F,$6E,$37,$6E,$FF,$FF,$FF,$EE,$BF,$FF,$4C,$DD,$FF,$AB
defb $3F,$9D,$3F,$FF,$FF,$EE,$EE,$EE,$BF,$EE,$BF,$CC,$46,$5D,$57,$AB
defb $AB,$C3,$AB,$C3,$AB,$43,$AB,$43,$AB,$43,$AB,$83,$03,$03,$03,$43
defb $DD,$BF,$DD,$BF,$3F,$EE,$CC,$EE,$FF,$EE,$FF,$7F,$EE,$FF,$FF,$FF
defb $3F,$3F,$3F,$7F,$9D,$6E,$9D,$CC,$EE,$9D,$EE,$DD,$DD,$FF,$FF,$FF
defb $FF,$3F,$FF,$3F,$EE,$3F,$BF,$9D,$FF,$CC,$FF,$CC,$FF,$FF,$EE,$FF
defb $7F,$9D,$7F,$9D,$DD,$CC,$DD,$EE,$FF,$EE,$FF,$EE,$EE,$FF,$FF,$FF
defb $DD,$CD,$DD,$D9,$CC,$EE,$CC,$FF,$CC,$FF,$CC,$DD,$CC,$DD,$CC,$DD
defb $3F,$7F,$3F,$FB,$FF,$B6,$FB,$9E,$FF,$CF,$FF,$F3,$7F,$B7,$7F,$EA
defb $FF,$EE,$DB,$FF,$CE,$E6,$F3,$F3,$B7,$D1,$7B,$6A,$3F,$3F,$3F,$3F
defb $FF,$FB,$FF,$E7,$FB,$8E,$FB,$DB,$FF,$A6,$FF,$E7,$7F,$6F,$7F,$3F
defb $DD,$BF,$FF,$EE,$CF,$FF,$DB,$DD,$E2,$F7,$CA,$D5,$CF,$C4,$C0,$6E
defb $EF,$F3,$BF,$B7,$BF,$3F,$EE,$3F,$EE,$9D,$CC,$CC,$CC,$EE,$FF,$FF
defb $6E,$CC,$3F,$CC,$6E,$CC,$CC,$CC,$CC,$CC,$CC,$DD,$FF,$FF,$DD,$EE
defb $3F,$3F,$3F,$6E,$3F,$CC,$3F,$CC,$CC,$CC,$CC,$EE,$DD,$FF,$FF,$FF
defb $C3,$C3,$43,$C3,$03,$C3,$03,$03,$03,$03,$FF,$03,$57,$AB,$FF,$FF
defb $C3,$C3,$C3,$C3,$C3,$C3,$C3,$83,$03,$03,$03,$57,$FF,$FF,$AB,$AB
defb $C3,$C3,$C3,$C3,$03,$C3,$03,$C3,$03,$43,$03,$03,$AB,$03,$FF,$03
defb $C3,$C3,$C3,$C3,$C3,$C3,$C3,$C3,$C3,$C3,$03,$C3,$03,$43,$AB,$03
defb $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
defb $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
defb $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00