extern char  __FASTCALL__ __LIB__   cpc_TestPrevKeyF(unsigned char tecla);	

extern char  __FASTCALL__ __LIB__   cpc_TestKeyFN(unsigned char tecla);	
extern char  __FASTCALL__ __LIB__   cpc_TestPrevKeyFN(unsigned char tecla);	

extern void __CALLEE__ __LIB__ cpc_BackupKeys(void);
extern void  __LIB__ cpc_ClearRectangle(unsigned char *Dest, unsigned short Width, unsigned short Height,unsigned char Data);
extern void __LIB__ cpc_StretchRect2Y(unsigned char *SourceBL, unsigned char *DestBL, unsigned short Width, unsigned short Height);

extern void __LIB__ cpc_DrawColouredBar0(unsigned char *Dest, unsigned short PixelWidth, unsigned char Height, unsigned char Colour);
extern int __FASTCALL__ __LIB__ cpc_NextScrLine(unsigned char *Dest);
extern void __FASTCALL__ __LIB__ cpc_EnableDTMessages(int enable);

/* wait for firmware to change colours set using SCR SET INK and SCR SET BORDER
Firmware interrupts must be enabled */
extern void __FASTCALL__ __LIB__ cpc_WaitFirmwareColourChange(void);

extern void __CALLEE__ __LIB__ cpc_AssignMultipleKey(unsigned short Count, unsigned short *KeyTable);

/* 8-bit random numbers */


/* set 8-bit random seed. randseed of 0 is bad! */
extern void __FASTCALL__ __LIB__ cpc_SetRandSeed(char);
/* return a random number in range 0-255 */
extern char __FASTCALL__ __LIB__ cpc_Random(void);
/* get a random number in range defined */
extern char __FASTCALL__ __LIB__ cpc_RandomInRange(char);
/* initialise random seed from Z80's R register */
extern void __FASTCALL__ __LIB__ cpc_InitDefaultRandSeed(void);

/* return Z80's R register */
extern int __FASTCALL__ __LIB__ cpc_GetRRegister(void);

extern void __FASTCALL__ __LIB__ cpc_SetSingleHeightChar();
extern void __FASTCALL__ __LIB__ cpc_SetDoubleHeightChar();
extern void __CALLEE__ __LIB__ cpc_PrintGphStr2(unsigned short, unsigned short);

/* waits for keyboard buffer to be empty, then waits for a char to be pressed and returns char */
extern int __FASTCALL__ __LIB__ cpc_WaitCharFirmware(void);

/* flag is 1 if number is written in form:
-  1
-100
- 34
etc

flag is 0 if number is written in form:

-1
-2
-300
*/
/* returns length of output string */
extern int __LIB__ cpc_ConvertNumberToAscii(unsigned char *Buffer, int Number, char Flag);

#define SCR_ADDR_FROM_COORD(x,y) \
	(unsigned char *)(0x0c000+(x)+(((y)>>3)*0x050)+(((y)&7)*0x0800))

#define SCR_CHAR_TO_BYTEX0(x) \
	(x<<1)
	
#define SCR_CHAR_TO_LINEY0(y) \
	(y<<3)
	
#define SCR_ADDR_FROM_CHAR0(x,y) \
	(unsigned char *)(0x0c000+((x)<<1)+((y)*0x050))
	
#define cpc_DisableInterrupt() \
	asm( "di" )

		
#define cpc_EnableInterrupt() \
	asm( "ei" )

		
#define M_BEGIN_ISR(name) void name(void) { asm("push\taf\npush\tbc\npush\tde\npush\thl\nex\taf,af\nexx\npush\taf\npush\tbc\npush\tde\npush\thl\nexx\nex\taf,af\npush\tix\npush\tiy\n");
#define M_END_ISR asm("pop\tiy\npop\tix\nex\taf,af\nexx\npop\thl\npop\tde\npop\tbc\npop\taf\nexx\nex\taf,af\npop\thl\npop\tde\npop\tbc\npop\taf\nei\nreti\n"); }

#define M_BEGIN_ISR_LIGHT(name) void name(void) { asm("push\taf\npush\tbc\npush\tde\npush\thl\n");
#define M_END_ISR_LIGHT asm("pop\thl\npop\tde\npop\tbc\npop\taf\nei\nreti\n"); }

extern int __LIB__ __CALLEE__ cpc_InVsync(void);
extern void __LIB__ __CALLEE__ cpc_WaitVsyncStart(void);
extern void __LIB__ __CALLEE__ cpc_WaitVsyncEnd(void);

	
	
/* copy a sprite rectangle.

SrcData is location of sprite data.
SrcX is byte offset into sprite.
SrcY is line offset into sprite.
SrcWidth is width of sprite in bytes.

DestScr is screen address to draw to.
DestWidth is width of rectangle to copy from sprite.
DestHeight is height of rectangle to copy from sprite.

NOTE: No bounds checking are done 
*/

extern void __LIB__ cpc_CopySpriteRectangleToScreen(unsigned char * DestScr, unsigned short DestHeight, unsigned short DestWidth, unsigned char *Source, unsigned short SrcX, unsigned short SrcY, unsigned char SrcWidth);

/* uses firmware to load binary */
extern int  __LIB__ cpc_LoadBinary(unsigned char *sFilename, unsigned char * Addr);
/* uses firmware to save binary */
extern int __LIB__ cpc_SaveBinary(unsigned char *sFilename, unsigned char *Start, unsigned short Length);

/* Error codes for cpc_LoadBinary, cpc_SaveBinary 

So far as it is possible the AMSDOS routines all have the same interface as their
cassette counterparts, although in some cases tile interpretation of tile return
parameters is different. Errors which are detected by both the cassette and disc
routines are returned carry false, zero false. Errors which are only detected by the disc
routines are returned carry false, zero true. This latter case corresponds to the cassette
routine BREAK condition. In both cases register A contains an error number.
When a routine fails (carry false) it returns a six bit error number in the A register. Bit
7 is set it the error has already been reported to the user. The error numbers are as
follows:
#0E the file is not open as expected.
#0F hard end of file.
#1A soft end of file.
#20 bad command, usually caused by an incorrect filename.
#21 file already exists.
#22 file doesn't exist.
#23 directory is full
#24 disc is full.
#25 disc has been changed with files open on it.
#26 file is read-only.
// 144
Errors detected by the floppy disc controller are reported as a bit significant value
between #40..#7F, i.e. bit 6 is always set. The other bits are returned as follows:
bit 5 data error - CRC error on data or ID field.
bit 4 overrun error.
bit 3 drive not ready - there is no disc in the drive.
bit 2 no data - can't find the sector.
bit 1 not writable - disc is write protected.
bit 0 address mark missing.
*/
#define AMSDOS_ERROR_CODE (1<<7)
#define AMSDOS_ERROR_STREAM (AMSDOS_ERROR_CODE+14)
#define AMSDOS_ERROR_HARD_EOF (AMSDOS_ERROR_CODE+15)
#define AMSDOS_ERROR_BAD_COMMAND (AMSDOS_ERROR_CODE+16)
#define AMSDOS_ERROR_FILE_ALREADY_EXISTS (AMSDOS_ERROR_CODE+17)
#define AMSDOS_ERROR_FILE_DOES_NOT_EXIST (AMSDOS_ERROR_CODE+18)
#define AMSDOS_ERROR_DIRECTORY_FULL (AMSDOS_ERROR_CODE+19)
#define AMSDOS_ERROR_DISC_FULL (AMSDOS_ERROR_CODE+20)
#define AMSDOS_ERROR_DISC_CHANGED_WITH_FILES_OPEN (AMSDOS_ERROR_CODE+21)
#define AMSDOS_ERROR_FILE_READ_ONLY (AMSDOS_ERROR_CODE+22)
#define AMSDOS_ERROR_SOFT_EOF (AMSDOS_ERROR_CODE+26)
#define DISC_CTRL_ERROR_CODE (1<<6)
#define DISC_CTRL_ADDRESS_MARK_MISSING (1<<0)
#define DISC_CTRL_DISC_WRITE_PROTECTED (1<<1)
#define DISC_CTRL_NO_DATA (1<<2)
#define DISC_CTRL_ERROR_DRIVE_NOT_READY (1<<3)
#define DISC_CTRL_OVERRUN (1<<4)
#define DISC_CTRL_DATA_ERROR (1<<5)

/* installs an interrupt routine. 

New interrupt handler installed which stores all registers, calls C function then restores all registers.
Doesn't change interrupt state. So disable interrupts before calling!

Interrupt function is a void func(void) */
extern void __FASTCALL__ __LIB__ cpc_InstallInterrupt(void *);
/* restore a stored interrupt handler, see cpc_InstallInterrupt. Doesn't change interrupt state. So disable interrupts before calling! */
extern void __CALLEE__ __LIB__ cpc_RestoreInterrupt(void);
/* saves old interrupt routine */
extern void __CALLEE__ __LIB__ cpc_StoreInterrupt(void);


/* restore a stored interrupt handler, see cpc_InstallInterrupt. Doesn't change interrupt state. So disable interrupts before calling! */
/* also restores af', bc', de', hl' */
/* use when upper and lower firmware jumpblock are still valid */
extern void __CALLEE__ __LIB__ cpc_RestoreFirmwareInterrupt(void);
/* saves old interrupt routine */
/* also stores af', bc', de', hl' */
/* use when upper and lower firmware jumpblock are still valid */
extern void __CALLEE__ __LIB__ cpc_StoreFirmwareInterrupt(void);

/* mode 0 pens */
#define pen0  0
#define pen1  128
#define pen2  8
#define pen3  136
#define pen4  32
#define pen5  160
#define pen6  40
#define pen7  168
#define pen8  2
#define pen9  130
#define pen10 10
#define pen11 138
#define pen12 34
#define pen13 162
#define pen14 42
#define pen15 170

#define PEN_BYTE0(pen) \
	(pen|(pen>>1))
	
	
/* Syx! */
extern void __FASTCALL__ asic_On(void);
extern void __FASTCALL__ asic_Off(void);
extern void __FASTCALL__ asic_Unlock(void);
extern void __CALLEE__ asic_Colour(int Index, int Colour);