XDEF _starkos_reloc_song

._starkos_reloc_song
	pop bc
	pop de
	pop hl
	push bc
	ld (SONGADR),hl
	ld (NEWOFFSET),de
;
	ld bc,4			;Get Base Adress of the song data
	add hl,bc
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
;
	ex de,hl
	or a
	sbc hl,de		;hl=Old data adr - New data adr
	ld (DIFFDATA),hl
;
;
	ld ix,(SONGADR)		;Code new Base Adress
	ld hl,(NEWOFFSET)
	ld (ix+4),l
	ld (ix+5),h
;
	ld b,8			;Change the offset of some 
	ld hl,9			;internal pointers
.CHINTLP	call CHOFFREL
	inc hl
	inc hl
	djnz CHINTLP
;
	ld hl,11
	call GETWORDREL
	ld (TRACKSTAB),de
	ld hl,13
	call GETWORDREL
	ld (STRACKSTAB),de
	ld hl,15
	call GETWORDREL
	ld (INSTRS),de
;
;Modify the TRACKS table
	ld hl,(STRACKSTAB)
	ld de,(TRACKSTAB)
	or a
	sbc hl,de
	srl h
	rr l
	ld c,l
	ld b,h
;
	ex de,hl
	call MODLINTAB
;
;
;
;
;
;Modify the STRACKS table
	ld hl,(INSTRS)
	ld (STRADEND+1),hl
	ld de,(STRACKSTAB)
;
.STRLOOP	ex de,hl
	ld a,(hl)
	inc hl
	srl a
	jr c,STROLP
	xor a
.STROLP	call CHOFF
	inc hl
	inc hl
	sub 1
	jr nc,STROLP
;
	ex de,hl
.STRADEND ld hl,0
	or a
	sbc hl,de
	jr nz,STRLOOP
;
;
;
;
;Modify the INSTRS table
	ld hl,(INSTRS)
	ld e,(hl)
	inc hl
	ld d,(hl)
	dec hl
	ex de,hl
	ld bc,(DIFFDATA)
	add hl,bc
	ld (INSTEND+1),hl
	or a
	sbc hl,de
	srl h
	rr l
	ld c,l
	ld b,h
;
	ex de,hl
	call MODLINTAB
;
;
;
;Modify the INSTRUMENTS data
	ld hl,(INSTRS)
	ld (PTINSTAB+1),hl
;
.PTINSTAB ld hl,0
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	ld (PTINSTAB+1),hl
;
	ex de,hl
	call CHOFF	;Modify instr internal pointers
	inc hl
	inc hl
	call CHOFF
;
.INSTEND ld hl,0
	ld de,(PTINSTAB+1)
	or a
	sbc hl,de
	jr nz,PTINSTAB
	ret
;
;
;
;
;
;
;***************
;LOW-LEVEL ROUTINES
;***************
;
;Add the offset to the word pointed by HL.
.CHOFF
	push hl
	push bc
;
	ld e,(hl)
	inc hl
	ld d,(hl)
	dec hl
	ld bc,(DIFFDATA)
	ex de,hl
	add hl,bc
	ex de,hl
	ld (hl),e
	inc hl
	ld (hl),d
;
;
	pop bc
	pop hl
	ret
;
;Add the offset to the relative adress in HL.
.CHOFFREL
	push hl
;
	call GETADR
	ld l,(ix+0)
	ld h,(ix+1)
	ld de,(DIFFDATA)
	add hl,de
	ld (ix+0),l
	ld (ix+1),h
;
	pop hl
	ret
;
;
;Return in IX the adress in the song from the relative
;adress given in HL.
.GETADR
	push de
	ld de,(SONGADR)
	add hl,de
	push hl
	pop ix
	pop de
	ret
;
;Return in DE the word pointed by HL
.GETWORD
	ld e,(hl)
	inc hl
	ld d,(hl)
	ret
;
;Return in DE the word pointed by the relative
;adress in HL.
.GETWORDREL
	call GETADR
	push ix
	pop hl
	call GETWORD
	ret
;
;
;Modify a linear table, composed of BC elem, pt by HL.
.MODLINTAB 
;
.MODLINLP call CHOFF
	inc hl
	inc hl
;
	dec bc
	ld a,c
	or b
	jr nz,MODLINLP
	ret
;
;
;******
;VARIABLES
;******
;
;
.SONGADR	defw 0		;Adress of the song in memory
.NEWOFFSET defw 0	;New adress of internal data
.DIFFDATA defw 0		;Diff between old and new data adr

.TRACKSTAB defw 0
.STRACKSTAB defw 0
.INSTRS defw 0
