;; disc loader 
;; similar loader can be used for cassette

scr_set_mode equ &bc0e
scr_set_border equ &bc38
cas_in_open equ &bc77
cas_in_direct equ &bc83
cas_in_close equ &bc7a
scr_set_ink equ &bc32
kl_rom_walk equ &bccb
mc_start_program equ &bd16
scr_initialise equ &bbff
txt_output equ &bb5a
km_wait_char equ &bb06

loader_load_addr equ &40

org loader_load_addr

load_start:

defb &11
include "temp\game_s.asm"
;;ld de,game_load_addr
call load_file

ld hl,game_colours_used
call set_palette

ld de,&c000
call load_file

defb &c3
include "temp\game_x.asm"
;;jp game_exe_addr

set_palette:
push hl
ld a,0
call scr_set_mode
pop hl

ld b,16
xor a

set_colours:
push af
push bc
ld c,(hl)
inc hl
ld b,c
push hl
call scr_set_ink
pop hl
pop bc
pop af
inc a
djnz set_colours
ret

game_colours_used:
defs 16

;; load a file

load_file:
ld hl,end_filename-1
inc (hl)
ld hl,filename
ld b,end_filename-filename
push de
ld de,&c000
call cas_in_open
pop hl
call cas_in_direct
jp cas_in_close

filename:
defb "bangel69.bi0"
end_filename:

;;------------------------------------------------------------------
;; Start for loader. Detects stuff and initialises colour for screen and game

exe_start:
ld hl,(&be7d)
ld a,(hl)
ld (drive+1),a

ld c,&ff					;; disable all roms
ld hl,start					;; execution address for program
jp mc_start_program		;; start it


start:
call kl_rom_walk


drive:
ld a,0
ld hl,(&be7d)
ld (hl),a


;; display message
ld hl,gs_col_msg
call display_msg
;; wait for key
wait_key:
call km_wait_char
;; check g or c
ld c,0
cp 'g'
jr z,set_colour_mode
cp 'G'
jr z,set_colour_mode
ld c,1
cp 'c'
jr z,set_colour_mode
cp 'C'
jr z,set_colour_mode
;; bad key pressed so beep
ld a,7
call txt_output
jr wait_key

set_colour_mode:
ld a,c
or a
jr z,set_colour_mode_gs
ld hl,game_colours
ld de,game_colours_used
ld bc,16
ldir
ld hl,title_colours
jr set_colour_mode_done
set_colour_mode_gs:
ld hl,gs_game_colours
ld de,game_colours_used
ld bc,16
ldir
ld hl,gs_title_colours
set_colour_mode_done:
call set_palette

;; use firmware to set border colours
ld bc,0
call scr_set_border

ld de,&4000
call load_file

call roll_start

;; begin load
jp load_start

display_msg:
ld a,(hl)
and &7f
bit 7,(hl)
jp nz,txt_output
inc hl
call txt_output
jr display_msg

gs_col_msg:
defb 4,1
defb 29,0,0
defb 28,0,0,0
defb 28,1,23,23
defb 28,2,14,14
defb 28,3,26,26
defb 14,0
defb 15,1
defb 31,14,6
defb "BLUE ANGEL 69"
defb 31,7,10
defb 15,2
defb "("
defb 15,3
defb "G"
defb 15,2
defb ")reen screen or ("
defb 15,3
defb "C"
defb 15,2
defb ")olour","?"+&80

;; colours for screen
title_colours:
include "gfx\bin\loadscrfirmpal.asm"

gs_title_colours:
db 0,26,5,6,15,9,23,25,17,19,15,18,5,9,3,17,0

game_colours:
include "gfx\bin\gamefirmpal.asm"

;; green screen game colours
gs_game_colours:
db 0,5,8,12,20,26,3,17,10,12,13,20,17,4,25,13

include "roll.asm"

end exe_start