;; disc loader 
;; similar loader can be used for cassette

scr_set_mode equ &bc0e
scr_set_border equ &bc38
cas_in_open equ &bc77
cas_in_direct equ &bc83
cas_in_close equ &bc7a
scr_set_ink equ &bc32
kl_rom_walk equ &bccb
mc_start_program equ &bd16

loader_load_addr equ &40

org loader_load_addr

load_start:
ld hl,(&be7d)
ld a,(hl)
ld (drive+1),a

ld c,&ff					;; disable all roms
ld hl,start					;; execution address for program
jp mc_start_program		;; start it


start:
call kl_rom_walk

drive:
ld a,0
ld hl,(&be7d)
ld (hl),a

ld hl,colours
call setup_screen

ld hl,crtc_vals
ld bc,&bc00
set_crtc_vals:
out (c),c
inc b
ld a,(hl)
out (c),a
dec b
inc hl
inc c
ld a,c
cp 14
jr nz,set_crtc_vals

defb &11
include "temp\game_s.asm"
;;ld de,game_load_addr
call load_file


defb &c3
include "temp\game_x.asm"
;;jp game_exe_addr

;; colours for screen
colours:
include "gfx\bin\loadscrfirmpal.asm"

game_colours:
include "gfx\bin\gamefirmpal.asm"

;; use firmware to init screen and colours
;; so that they are persistant while
;; game is loaded by the firmware.

setup_screen:
push hl
;; use firmware to set screen mode
ld a,0
call scr_set_mode

;; use firmware to set border colours
ld bc,0
call scr_set_border


;; use firmware to set colours
ld b,16
pop hl
xor a

set_colours:
push af
push bc
ld c,(hl)
inc hl
ld b,c
push hl
call scr_set_ink
pop hl
pop bc
pop af
inc a
djnz set_colours
ret


;; load a file

load_file:
ld hl,end_filename-1
inc (hl)
ld hl,filename
ld b,end_filename-filename
push de
ld de,&c000
call cas_in_open
pop hl
call cas_in_direct
jp cas_in_close


crtc_vals:
defb &3f, 40, 46, &8e, &26, &00, 25, 30, &00, &07, &00,&00,&30,&00

filename:
defb "bangel69.bi1"
end_filename:

end load_start