;; tape loader 

loader_load_addr equ &100

org loader_load_addr
nolist

;; disable interrupts
di
;; set stack
ld sp,loader_load_addr

;; mode 0
ld bc,&7f00+10001100b
out (c),c

ld hl,colours+15
call set_palette

ld e,14
ld hl,crtc_vals
ld bc,&bc00
set_crtc_vals:
out (c),c
inc b
ld a,(hl)
out (c),a
inc hl
dec b
inc c
dec e
jr nz,set_crtc_vals


;; load screen
ld ix,&c000
ld de,&4000
ld a,&ff
call ldbyts
jp nc,0

;; load code
defb &dd,&21
include "temp\game_s.asm"
defb &11
include "temp\game_l.asm"
ld a,&ff
call ldbyts
jp nc,0

ld hl,game_colours+15
call set_palette

;; load screen
ld ix,&c000
ld de,&4000
ld a,&ff
call ldbyts
jp nc,0

;; execute code
defb &c3
include "temp\game_x.asm"

set_palette:
push hl
ld hl,&c000
ld e,l
ld d,h
inc hl
ld (hl),0
ld bc,&3fff
ldir
pop hl
ld bc,&7f00+15
set_colours2:
out (c),c
ld a,(hl)
out (c),a
dec hl
dec c
jp p,set_colours2
ret


include "specld2.asm"

;; colours for screen
colours:
include "gfx\bin\loadscrpal.asm"
game_colours:
include "gfx\bin\gamepal.asm"

crtc_vals:
defb &3f, 40, 46, &8e, &26, &00, 25, 30, &00, &07, &00,&00,&30,&00
