;; tape loader 

loader_load_addr equ &40
km_wait_char equ &bb06
txt_output equ &bb5a
scr_initialise equ &bbff

org loader_load_addr
;;nolist

load_start:

;; load code
defb &dd,&21
include "temp\game_s.asm"
defb &11
include "temp\game_l.asm"
ld a,&ff
call topoload
jp nc,0

ld hl,game_colours_used+15
call set_palette

;; load screen
ld ix,&c000
ld de,&4000
ld a,&ff
call topoload
jp nc,0


;; execute code
defb &c3
include "temp\game_x.asm"

set_palette:
push hl
ld hl,&c000
ld e,l
ld d,h
inc de
ld (hl),0
ld bc,&3fff
ldir
pop hl
ld bc,&7f00+15
set_colours2:
out (c),c
ld a,(hl)
out (c),a
dec hl
dec c
jp p,set_colours2
ret

game_colours_used:
defs 16

;;include "specld2p.asm"

include "topoload.asm"

;;------------------------------------------------------------------
;; Start for loader. Detects stuff and initialises colour for screen and game

exe_start:
call scr_initialise

ld e,14
ld hl,crtc_vals
ld bc,&bc00
set_crtc_vals:
out (c),c
inc b
ld a,(hl)
out (c),a
inc hl
dec b
inc c
dec e
jr nz,set_crtc_vals

;; display message
ld hl,gs_col_msg
call display_msg
;; wait for key
wait_key:
call km_wait_char
;; check g or c
ld c,0
cp 'g'
jr z,set_colour_mode
cp 'G'
jr z,set_colour_mode
ld c,1
cp 'c'
jr z,set_colour_mode
cp 'C'
jr z,set_colour_mode
;; bad key pressed so beep
ld a,7
call txt_output
jr wait_key

set_colour_mode:
;; display loading message
push bc
ld hl,load_msg
call display_msg
pop bc
;; start loading
di
;; set stack
ld sp,load_start-2
push bc
;; load screen
ld ix,&4000
ld de,&4000
ld a,&ff
call topoload
jp nc,0

pop bc
;; now based on choice, set colours
ld a,c
or a
jr z,set_colour_mode_gs
ld hl,game_colours
ld de,game_colours_used
ld bc,16
ldir
ld hl,title_colours+15
jr set_colour_mode_done
set_colour_mode_gs:
ld hl,gs_game_colours
ld de,game_colours_used
ld bc,16
ldir
ld hl,gs_title_colours+15
set_colour_mode_done:
call set_palette

;; mode 0
ld bc,&7f00+%10001100
out (c),c

;; and show
call roll_start

;; begin load
jp load_start

display_msg:
ld a,(hl)
and &7f
bit 7,(hl)
jp nz,txt_output
inc hl
call txt_output
jr display_msg

gs_col_msg:
defb 4,1
defb 29,0,0
defb 28,0,0,0
defb 28,1,23,23
defb 28,2,14,14
defb 28,3,26,26
defb 14,0
defb 15,1
defb 31,14,6
defb "BLUE ANGEL 69"
defb 31,7,10
defb 15,2
defb "("
defb 15,3
defb "G"
defb 15,2
defb ")reen screen or ("
defb 15,3
defb "C"
defb 15,2
defb ")olour","?"+&80

load_msg:
defb 4,1
defb 15,1
defb 31,1,24
defb "Loading please wait...","."+&80

;; colours for screen
title_colours:
include "gfx\bin\loadscrpal.asm"

gs_title_colours:
;;db 0,26,5,6,15,9,23,25,17,19,15,18,5,9,3,17,0
defb &54,&4b,&5d,&4c,&4e,&56,&5b,&43,&4f,&42,&4e,&52,&5d,&56,&5c,&4f

game_colours:
include "gfx\bin\gamepal.asm"

;; green screen game colours
gs_game_colours:
;;db 0,5,8,12,20,26,3,17,10,12,13,20,17,4,25,13
defb &54,&5d,&5d,&5e,&53,&4b,&5c,&4f,&46,&5e,&40,&53,&4f,&58,&43,&40

crtc_vals:
defb &3f, 40, 46, &8e, &26, &00, 25, 30, &00, &07, &00,&00,&30,&00

include "roll.asm"

end exe_start